#!c:/perl/bin/perl

##############################################################################
# MTVWebdesign mailinglist manager (Arch)                        Version 2.0
# admin.cgi: Webmaster script
# Copyright 1999-2000 Maarten Veerman mtveerman@mindless.com
# MTVWebdesign:    http://mtvwebdesign.hypermart.net/ (http://mtvwebdesign.hypermart.net/scripts/)
##############################################################################
# COPYRIGHT NOTICE
# Copyright 1999-2000 Maarten Veerman  All Rights Reserved.
#
# Arch may be used and modified so long as this
# copyright notice and the comments above remain intact.  By using this
# code you agree to indemnify Maarten Veerman from any liability that
# might arise from its use.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  In other words, please ask first before you try and
# make money off of my program in any way.
#
# Obtain permission before redistributing this software over the Internet or
# in any other medium. In all cases copyright and header must remain intact
#
# Please send bug-reports to cgi-bugs@mtvwebdesign.hypermart.net
##############################################################################
#
# Script tested locally:
# Pentium 400Mhz, 128MB RAM, Windows 98, Apache 1.3.4 (win32), Perl, MS Internet Explorer 5.0, Netscape 4.05.
#
##############################################################################
# Please do not remove the following lines:
$scriptname = "Arch!";
$version = "2.0";
##############################################################################

# First we need to call some extra functions.
# Please note that you have to change the 2 "require" lines!
use CGI::Carp qw(fatalsToBrowser); # Provides you with fatal error message if they occur.
use CGI qw/:standard/;
require 'c:/sambar/htdocs/arch/arch.conf';
require $mtvwebdesignlib;
require $dbunderpath;
$dbdir = &dbdir_;
require $dbunder;

main: {
  &getinput;
  &GetCookies;
  
# Since we want to use the cookies with several scripts we need to set the
# cookie path. A lot of people might have problems with this, so we do it
# automatically.
  @paths = split(/\//, $ENV{'SCRIPT_NAME'});
  for ($I=1;$paths[$I+1] ne '';$I++) {
    $Cookie_Path .= "\/$paths[$I]";
  }
  
  if ($db_dir !~ m/\/$/) { $db_dir = $db_dir . '/'; }
  
  if (lc $FORM{'action'} eq "login2") { &login2; }
  elsif (lc $FORM{'action'} eq "logout") { &logout("name,email,mln,lp"); }
  elsif (lc $FORM{'action'} eq "info") { &info; }
  elsif (lc $FORM{'action'} eq "more_info") { &more_info; }
  elsif (lc $FORM{'action'} eq "dl") { &dl; }
  elsif (lc $FORM{'action'} eq "dl2") { &dl2; }
  elsif (lc $FORM{'action'} eq "changepass") { &changepass; }
  elsif (lc $FORM{'action'} eq "changepass2") { &changepass2; }
  else { &mainpage; }
  
}

sub mainpage {
  &login unless $Cookies{'loggedinwm'};
  
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader("Mainpage for webmaster");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Mainpage for webmaster</h2>
      ~;
      
      if (!$enc_web_pass) {
        print qq~
        <center>
        <font color="#FF0000">Please note that the password for the webmaster is not encrypted at this moment! For your safety you should change your password and make sure you select the Encrypt option!</font>
        </center>
        <p>
        ~;
      }
      
      print qq~
      Please select one of the following options:<p>
      <ol>
      <li><a href="$script_location?action=cnml">Create a new mailing list</a>
      <li><a href="$ENV{'SCRIPT_NAME'}?action=info">View all mailing lists </a> (also: delete, info about certain lists, etc.)
      <li><a href="$ENV{'SCRIPT_NAME'}?action=changepass">Change your password</a>
      <li><a href="$ENV{'SCRIPT_NAME'}?action=logout">Logout</a>
      </ol>
      ~;
    }
    print "$line";
  }
  &powered_by;
}

sub login {
  local($mess) = @_;
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader("Webmasterlogin");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Webmasterlogin</h2>
      ~;
      
      if ($mess) {
        print qq~
        <center>
        <font color="#FF0000">$mess</font><p>
        </center>
        ~;
      }
      
      print qq~
      In order to get to the admin functions, you need to provide the password:<p>
      <form action="$ENV{'SCRIPT_NAME'}" method="post">
      <input type="hidden" name="action" value="login2">
      <input type="hidden" name="id" value="$id">
      <center>
      <table cellpadding="5" cellspacing="0" border="1">
      <tr><td>Please enter the password:</td><td><input type="password" name="pass"></td></tr>
      <tr><td colspan="2" align="center"><input type="submit"></td></tr>
      </table>
      </center>
      </form>
      ~;
    }
    print "$line";
  }
  &powered_by("nologout");
  exit;
}

sub login2 {
# Check the login
  
  if ($enc_web_pass) { $FORM{'pass'} = crypt($FORM{'pass'}, Mv); }
  
  if ($FORM{'pass'} eq $webmasterpass) {
    $Cookies{'loggedinwm'} = "1";
    &SetCookies("loggedinwm","1");
    &mainpage;
  }
  else {
    &login("There was a problem with the password you provided. Please try again.");
  }
}

sub info {
  &login unless $Cookies{'loggedinwm'};
  
  &opendb;
  @data = &SelectFromTable_("main","AND","lcname,realname,owner,email_of_owner,use,warned");
  &closedb;
  
  print "Content-type: text/html\n";
  &expires_header("+5m");
  print "\n";
  &pageheader("A list of all the mailing lists");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Information page</h2>
      Here are all the lists. Click on the listname for more information.<p>
      <form action="$ENV{'SCRIPT_NAME'}" method="post">
      <input type="hidden" name="action" value="dl">
      <input type="hidden" name="id" value="$id">
      <center>
      <table cellpadding="5" cellspacing="0" border="1">
      <tr><td>&nbsp;</td><td align="center"><b>Name of list:</b></td><td align="center"><b>Owner:</b></td><td align="center"><b>In use?</b></td><td align="center"><b>Growing old?</b></td></tr>
      ~;
      
      for($c=1;$c < scalar @data;$c++) {
        ($lcname,$realname,$owner,$email_of_owner,$use,$warned) = split(/\/,$data[$c]);
        print qq~
        <tr><td><input type="checkbox" name="dln" value="$lcname"></td><td align="center"><a href="$ENV{'SCRIPT_NAME'}?action=more_info&mln=$lcname">$realname</a></td><td align="center"><a href="mailto:$email_of_owner">$owner</a></td><td align="center">
        ~;
        if ($use eq "0") { print "no"; }
        else { print "yes"; }
        print qq~
        </td><td align="center">
        ~;
        if ($warned eq "0") { print "no"; }
        else { print "yes"; }
        print qq~
        </td></tr>
        ~;
        
        
      }
      
      print qq~
      <tr><td colspan="5" align="center"><input type="submit" value="Delete selected lists"></td></tr>
      </table>
      </center>
      </form>
      ~;
      
    }
    print "$line";
  }
  &powered_by;
  exit;
}

sub more_info {
  &login unless $Cookies{'loggedinwm'};
  
  &opendb;
  %info = &BinarySelect_("main","$FORM{'mln'}");
  @addresses = &SelectFromTable_("addresses","AND","username,email","listname|eq|$FORM{'mln'}");
  &closedb;
  
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader("Information for $info{'realname'}");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Information for $info{'realname'}</h2>
      This is the information page for $info{'realname'}. You'll see everything we know about this list on this page.
      <hr noshade>
      Name of the mailing list: <b>$info{'realname'}</b><br>
      Name of owner: <b>$info{'owner'}</b><br>
      Email of owner: <b>$info{'email_of_owner'}</b><br>
      ~;
      
      if ($info{'footer'} ne '') {
        $info{'footer'} =~ s/\n/<br>/ig;
        print qq~
        Footer:<br><b>$info{'footer'}</b><p>
        ~;
      }
      else {
        print qq~
        No footer is provided.<p>
        ~;
      }
      
      if ($info{'number_of_posts'} > 0) {
        print qq~
        Number of posts: <b>$info{'number_of_posts'}</b><br>
        Date of last post: <b>$info{'last_date_of_post'}</b><p>
        ~;
      }
      else {
        print qq~
        $info{'owner'} never posted a message to the list<p>
        ~;
      }
      
      print qq~
      <hr noshade>
      <h3>Domains</h3>
      Here is a list of all the domains where the subscribers come from:
      <center>
      <table cellpadding="5" cellspacing="0" border="1">
      <tr><td><b>Number</b></td><td><b>Domain</b></td></tr>
      ~;
      
      for($e=1;$e < scalar @addresses;$e++) {
        ($username,$address) = split(/\/,$addresses[$e]);
        @email = split(/\./,$address);
        if ($hash{$email[$#email]}) {
            $hash{$email[$#email]}++;
            }
            else {
              $hash{$email[$#email]} = 1;
              }
            }
            
            foreach $domain (sort %hash) {
              if ($hash{$domain} ne '') {
                print "<tr><td align=\"center\">" . $hash{$domain} . "</td><td align=\"center\">." . $domain . "</td></tr>";
              }
            }
            
            print qq~
            </table>
            </center>
            <hr noshade>
            <h3>Subscribers</h3>
            Here is the list of subscribers to the $info{'realname'} mailing list:<p>
            <form action="$ENV{'SCRIPT_NAME'}" method="post">
            <input type="hidden" name="action" value="de">
            <input type="hidden" name="id" value="$id">
            <center>
            <table cellpadding="5" cellspacing="0" border="1">
            <tr><td align="center"><b>Name of subscriber</b></td><td align="center"><b>Email of subscriber</b></td></tr>
            ~;
            
            for($e=1;$e < scalar @addresses;$e++) {
              ($username,$address) = split(/\/,$addresses[$e]);
              print "<tr><td align=\"center\">$username</td><td align=\"center\"><a href=\"mailto:$address\">$address</a></td></tr>\n";
            }
            
            print qq~
            </table>
            </center>
            </form>
            <center><FORM><INPUT type="button" value="Back" onClick="history.go(-1)"></FORM></center>
            ~;
            
          }
          print "$line";
        }
        &powered_by;
        exit;
        
      }
      
      sub dl {
        &login unless $Cookies{'loggedinwm'};
        
        print "Content-type: text/html\n\n";
        &pageheader("Are you sure?");
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            print qq~
            <h2>Are your sure?</h2>
            Are you sure you want to delete the following mailing lists?<p>
            <form action="$ENV{'SCRIPT_NAME'}" method="post">
            <input type="hidden" name="action" value="dl2">
            <input type="hidden" name="id" value="$id">
            <center>
            <table cellpadding="5" cellspacing="0" border="1">
            <tr><td>&nbsp;</td><td align="center"><b>Name of list:</b></td><td align="center"><b>Owner:</b></td><td align="center"><b>In use?</b></td><td align="center"><b>Growing old?</b></td></tr>
            ~;
            
            @lists = split(/,/,$FORM{'dln'});
            
            &opendb;
            
            foreach $list (sort @lists) {
              %info = &BinarySelect_("main","$list");
              print qq~
              <tr><td><input type="checkbox" name="dln" value="$info{'lcname'}" checked></td><td align="center"><a href="$ENV{'SCRIPT_NAME'}?action=more_info&mln=$info{'lcname'}">$info{'realname'}</a></td><td align="center"><a href="mailto:$info{'email_of_owner'}">$info{'owner'}</a></td><td align="center">
              ~;
              if ($info{'use'} eq "0") { print "no"; }
              else { print "yes"; }
              print qq~
              </td><td align="center">
              ~;
              if ($info{'warned'} eq "0") { print "no"; }
              else { print "yes"; }
              print qq~
              </td></tr>
              ~;
            }
            
            &closedb;
            
            print qq~
            <tr><td colspan="3" align="center"><input type="submit" value="Yes, I am sure"></form></td><td colspan="2" align="center"><FORM><INPUT type="button" value="No, I want to get back" onClick="history.go(-1)"></FORM></td></tr>
            </table>
            </center>
            ~;
            
          }
          print "$line";
        }
        &powered_by;
        exit;
      }
      
      sub dl2 {
        &login unless $Cookies{'loggedinwm'};
        
        @lists = split(/,/,$FORM{'dln'});
        
        &opendb;
        foreach $list (sort @lists) {
          %inf = &BinarySelect_("main","$list");
          &email("$inf{'owner'}","$inf{'email_of_owner'}","$inf{'realname'}");
          &DeleteFromTable_("main","AND","lcname|eq|$list");
          &DeleteFromTable_("addresses","AND","listname|eq|$list");
          push @deleted_lists, $inf{'realname'};
        }
        &closedb;
        
        print "Content-type: text/html\n\n";
        &pageheader("Lists deleted");
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            print qq~
            <h2>Lists deleted</h2>
            The following lists have been deleted:<p>
            <b>
            ~;
            foreach $list (sort @deleted_lists) {
              print $list . "<br>\n";
            }
            print qq~
            </b><p>
            The owners of the lists have been notified.<p>
            Please <a href="$ENV{'SCRIPT_NAME'}?action=mainpage">click here </a>to get back to the main page.
            ~;
          }
          print "$line";
        }
        &powered_by;
        exit;
      }
      
      sub email {
        local(@emailinfo) = @_;
        
        open(MAIL, "$mailprog");
        print MAIL "To: $emailinfo[1] ($emailinfo[0])\n";
        print MAIL "From: $webmasteremail ($servicename)\n";
        print MAIL "X-Mailer: $servicename, the ultimate mailinglist manager by MTVWebdesign\n";
        print MAIL "Subject: Your $emailinfo[2] mailinglist has been deleted\n\n";
        print MAIL qq~
        Dear $emailinfo[0],
        
        Your mailing list has been deleted manually by the $servicename webmaster.
        
        Yours,
        $webmastername
        ~;
        print MAIL "\n\n";
        print MAIL "-" x 75 . "\n";
        print MAIL "$servicename is powered by an MTVWebdesign script\nhttp://mtvwebdesign.hypermart.net\n";
        close(MAIL);
      }
      
      sub changepass {
        &login unless $Cookies{'loggedinwm'};
        print "Content-type: text/html\n\n";
        &pageheader("Change the password for the webmaster");
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            print qq~
            <h1>Change the password for the webmaster</h1>
            Please fill out the form below and press the submit button.
            <form action="$ENV{'SCRIPT_NAME'}" method="post">
            <input type="hidden" name="action" value="changepass2">
            <input type="hidden" name="id" value="$id">
            <table cellpadding="5" cellspacing="0" border="1">
            <tr><td>Please enter your old password:</td><td><input type="password" name="oldpass"></td></tr>
            <tr><td>Please enter your new password:</td><td><input type="password" name="newpass1"></td></tr>
            <tr><td>Please enter your new password again:</td><td><input type="password" name="newpass2"></td></tr>
            <tr><td colspan="2" align="center">Please check this box if you want to encrypt your password (We strongly advise this!): <input type="checkbox" name="crypt" CHECKED></td></tr>
            <tr><td colspan="2" align="center"><input type="submit"></td></tr>
            </table>
            </form>
            ~;
          }
          print "$line";
        }
        &powered_by;
        exit;
      }
      
      sub changepass2 {
        &login unless $Cookies{'loggedinwm'};
        
        if ($enc_web_pass) { $FORM{'oldpass'} = crypt($FORM{'oldpass'}, Mv); }
        &errors("oldpass") if ($FORM{'oldpass'} ne $webmasterpass);
        &errors("newpass") if ($FORM{'newpass1'} ne $FORM{'newpass2'} || !$FORM{'newpass1'});
        
        if ($FORM{'crypt'}) { $FORM{'newpass1'} = crypt($FORM{'newpass1'}, Mv); }
        
        
        open(SETUP, "+<$setup_file") || die "Cannot open $setup_file";
        flock(SETUP, 2) if $use_flock;
        
# Seek the beginning of the file.
        seek (SETUP, 0, 0);
# Now place all the lines in an array....
        @lines = <SETUP>;
        
# Seek the beginning of the file again.....
        seek (SETUP, 0, 0);
# ....and empty the file.....
        truncate (SETUP, 0);
        
        foreach $line (@lines) {
          if ($line =~ /\$webmasterpass\s*=\s*["\'][^"\']+["\']\;/) {
            print SETUP "\$webmasterpass = \"$FORM{newpass1}\"\;\n";
            if ($FORM{'crypt'}) {
              print SETUP "\$enc_web_pass = \"1\"\;\n";
            }
          }
          elsif ($line =~ /\$enc_web_pass\s*=\s*["\'][^"\']+["\']\;/) {
            print SETUP "";
          }
          else {
            print SETUP "$line";
          }
        }
        flock(SETUP, 8) if $use_flock;
        close(SETUP);
        
        print "Content-type: text/html\n\n";
        &pageheader("Password changed");
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            print qq~
            <h1>Password changed</h1>
            Your webmaster password was succesfully changed! Please <a href="$ENV{'SCRIPT_NAME'}?$id">click here</a> to go back to the mainpage!
            ~;
          }
          print "$line";
        }
        &powered_by;
        exit;
      }
      
      sub errors {
        local($errors) = @_;
        
        print "Content-type: text/html\n";
        &expires_header("now");
        print "\n";
        &pageheader('An error occured');
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            
            if ($errors eq 'oldpass') {
              print qq~
              <h2>Problem with password</h2>
              Sorry, the old password you provided is not correct, please try again.
              ~;
            }
            
            elsif ($errors eq 'newpass') {
              print qq~
              <h2>Problem with password</h2>
              Sorry, the two new passwords you provided are not the same. Please try again.
              ~;
            }
            
# If the error type was not found:
            else {
              print qq~
              <h2>Error Undefined!</h2> Please contact <a href="mailto:$webmasteremail?subject=Error_Undefined">$webmasteremail</a> with details of this error.
              ~;
            }
            
# Back button:
            print qq~
            <center><FORM><INPUT type="button" value="Back" onClick="history.go(-1)"></FORM></center>
            ~;
          }
          print "$line";
        }
        &powered_by;
        exit; # Exit the script when an error occured.
      }
      
      sub opendb {
        &LockAndOpen_("","Arch");
        &CreateDatabase_;
      }
      
      sub closedb {
        &UnlockAndCommit_;
      }
