#!c:/perl/bin/perl

##############################################################################
# MTVWebdesign mailinglist manager (Arch)                        Version 2.0
# remove.cgi: Remove subscribers
# Copyright 1999-2000 Maarten Veerman mtveerman@mindless.com
# MTVWebdesign:    http://mtvwebdesign.hypermart.net/ (http://mtvwebdesign.hypermart.net/scripts/)
##############################################################################
# COPYRIGHT NOTICE
# Copyright 1999-2000 Maarten Veerman  All Rights Reserved.
#
# Arch may be used and modified so long as this
# copyright notice and the comments above remain intact.  By using this
# code you agree to indemnify Maarten Veerman from any liability that
# might arise from its use.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  In other words, please ask first before you try and
# make money off of my program in any way.
#
# Obtain permission before redistributing this software over the Internet or
# in any other medium. In all cases copyright and header must remain intact
#
# Please send bug-reports to cgi-bugs@mtvwebdesign.hypermart.net
##############################################################################
#
# Script tested locally:
# Pentium 400Mhz, 128MB RAM, Windows 98, Apache 1.3.4 (win32), Perl, MS Internet Explorer 5.0, Netscape 4.05.
#
##############################################################################
# Please do not remove the following lines:
$scriptname = "Arch!";
$version = "2.0";
##############################################################################

# First we need to call some extra functions.
# Please note that you have to change the 2 "require" lines!
use CGI::Carp qw(fatalsToBrowser); # Provides you with fatal error message if they occur.
use CGI qw/:standard/;
require 'c:/sambar/htdocs/arch/arch.conf';
require $mtvwebdesignlib;
require $dbunderpath;
$dbdir = &dbdir_;
require $dbunder;

main: {
  &getinput;
  &GetCookies;
  &check_url;
  
# Since we want to use the cookies with several scripts we need to set the
# cookie path. A lot of people might have problems with this, so we do it
# automatically.
  @paths = split(/\//, $ENV{'SCRIPT_NAME'});
  for ($I=1;$paths[$I+1] ne '';$I++) {
    $Cookie_Path .= "\/$paths[$I]";
  }
  
  if (lc $FORM{'action'} eq 'ru') { &ru; }
  elsif (lc $FORM{'action'} eq 'ru2') { &ru2; }
  
  else { &ru; }
  exit;
  
}

sub get_name {
  local($myname) = @_;
  
  $myname =~ s/\W//g;
  $filename = lc $myname;
  
}

sub ru {
#Remove user
  local ($mess) = @_;
  
  print "Content-type: text/html\n\n";
  &pageheader("Remove me form a list");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Unsubscribe from a mailing list</h2>
      ~;
      
      if ($mess) {
        print qq~
        <font color="#FF0000">Note: there is a problem with the listname you provided. Please try again, by selecting a list from the drop down menu on this page.</font><p>
        ~;
      }
      
      print qq~
      Please fill out the form below:
      <form action="$ENV{'SCRIPT_NAME'}" method="post">
      <input type="hidden" name="action" value="ru2">
      <input type="hidden" name="id" value="$id">
      <center>
      <table cellpadding="5" cellspacing="0" border="1">
      <tr><td>Name of the list:</td><td>
      ~;
      if ($FORM{'mln'} && !$mess) { print "<b><input type=\"hidden\" name=\"mln\" value=\"$FORM{'mln'}\">" . $FORM{'mln'} . "</b>";}
      else {
        &opendb;
        @data = &SelectFromTable_("main","AND","lcname,realname");
        &closedb;
        print "<select name=\"mln\"><option>Select a list";
        
        for($w=1;$w < scalar @data;$w++) {
          ($lcname,$realname) = split(/\/,$data[$w]);
          print "<option value=\"$lcname\">$realname\n";
        }
        
        print qq~
        </select>
        ~;
      }
      
      print qq~
      </td></tr>
      <tr><td>Please enter your email address:</td><td><input type="text" name="email"></td></tr>
      <tr><td colspan="2" align="center"><input type="submit"></td></tr>
      </table>
      </form>
      ~;
    }
    print "$line";
  }
  &powered_by("nologout");
  exit;
}

sub ru2 {
  &get_name($FORM{'mln'});
  
  &check_email($FORM{'email'});
  
  &opendb;
  %info = &BinarySelect_("main","$filename");
  
  if (!$info{'lcname'}) {
    &closedb;
    &ru("nosuchlist");
  }
  
  @check = eval(&DeleteFromTable_("addresses","AND","listname|eq|$filename","email|eq|$FORM{'email'}"));
  
  &closedb;
  
  &errors("not removed") if ($check[0] != 0);
  
  open MAIL, $mailprog or die "Cannot open $mailprog, so no emails can be sent. You are subscribed though!";
  print MAIL "From: $info{'email_of_owner'} ($info{'owner'}, owner of the $info{'realname'} mailing list)\n";
  print MAIL "To: $FORM{'email'}\n";
  print MAIL "X-Mailer: $servicename, the ultimate mailinglist manager by MTVWebdesign\n";
  print MAIL "Subject: You are removed from the $info{'realname'} mailing list\n\n";
  print MAIL qq~
  We confirm, by this email, that you have been removed from the $info{'realname'} mailing list, and you will receive no further emails from us.
  
  Thanks for being a subscriber!
  $info{'owner'}
  ~;
  print MAIL "-" x 75 . "\n";
  print MAIL "This service is powered by a MTVWebdesign script\nhttp://mtvwebdesign.hypermart.net\n";
  close MAIL;
  
  if ($FORM{'sent_to'} && $FORM{'sent_to'} =~ m/^http/) { print "Location: $FORM{'sent_to'}\n\n"; exit;}
  
  print "Content-type: text/html\n\n";
  &pageheader("Removed from $info{'realname'}");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Removed from $info{'realname'}</h2>
      You successfully unsubscribed from the $info{'realname'} mailing list.
      Please click the back button on your browser to continue.
      ~;
    }
    print "$line";
  }
  &powered_by("nologout");
  exit;
}

sub errors {
  local($errors) = @_;
  
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader('An error occured');
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      if ($errors eq 'with the email address you gave') {
        print qq~
        <h2>Invalid email address</h2>
        The following email address is invalid: $invalidmail<br>
        Please press the back button and try again.
        ~;
      }
      
      elsif ($errors eq 'not removed') {
        print qq~
        <h2>Not removed</h2>
        I'm sorry but you cannot be removed from the $info{'realname'} mailing list, since you aren't in the database. Please check your email address.
        ~;
      }
      
# If the error type was not found:
      else {
        print qq~
        Error Undefined! Please contact <a href="mailto:$webmasteremail?subject=Error_Undefined">$webmasteremail</a> and give details as to what may have caused the error.
        ~;
      }
      
# Back button:
      print qq~
      <center><FORM><INPUT type="button" value="Back" onClick="history.go(-1)"></FORM></center>
      ~;
    }
    print "$line";
  }
  &powered_by;
  exit; # Exit the script when an error occured.
}

sub opendb {
  &LockAndOpen_("","Arch");
  &CreateDatabase_;
}

sub closedb {
  &UnlockAndCommit_;
}
